package com.sun.corba.se.spi.protocol;

import org.omg.CORBA.CompletionStatus;
import com.sun.corba.se.spi.ior.IOR;
import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.UnknownException;
import com.sun.corba.se.spi.servicecontext.ServiceContexts;
import com.sun.corba.se.impl.protocol.giopmsgheaders.LocateRequestMessage;
import com.sun.corba.se.impl.protocol.giopmsgheaders.RequestMessage;
import com.sun.corba.se.pept.protocol.ProtocolHandler;

public interface CorbaProtocolHandler extends ProtocolHandler
{
    public abstract void handleRequest(RequestMessage p0, CorbaMessageMediator p1);
    
    public abstract void handleRequest(LocateRequestMessage p0, CorbaMessageMediator p1);
    
    public abstract CorbaMessageMediator createResponse(CorbaMessageMediator p0, ServiceContexts p1);
    
    public abstract CorbaMessageMediator createUserExceptionResponse(CorbaMessageMediator p0, ServiceContexts p1);
    
    public abstract CorbaMessageMediator createUnknownExceptionResponse(CorbaMessageMediator p0, UnknownException p1);
    
    public abstract CorbaMessageMediator createSystemExceptionResponse(CorbaMessageMediator p0, SystemException p1, ServiceContexts p2);
    
    public abstract CorbaMessageMediator createLocationForward(CorbaMessageMediator p0, IOR p1, ServiceContexts p2);
    
    public abstract void handleThrowableDuringServerDispatch(CorbaMessageMediator p0, Throwable p1, CompletionStatus p2);
}
